/// @addtogroup auxil
/// @{

/////////////////////////////////////////////////////////////////////////////
/// @file ofstreamcout.h
///
/// @author Marian Mrozek
/////////////////////////////////////////////////////////////////////////////

// Copyright (C) 2000-2006 by the CAPD Group.
//
// This file is part of the CAPD library.  This library is free software;
// you can redistribute it and/or modify it under the terms of the GNU
// General Public License as published by the Free Software Foundation;
// either version 2 of the License, or (at your option) any later version.
//
// This library is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU General Public License for more details.
//
// You should have received a copy of the GNU General Public License along
// with this software; see the file "license.txt".  If not, write to the
// Free Software Foundation, Inc., 59 Temple Place - Suite 330, Boston,
// MA 02111-1307, USA.

#ifndef _OFSTREAMCOUT_H_
#define _OFSTREAMCOUT_H_
#include <iostream>
#include <fstream>
class ofstreamcout : public std::ofstream{
  bool streaming;
  public:

  friend ofstreamcout& operator<<(ofstreamcout& out, std::ostream& (*op)(std::ostream&) ){
    if(&out and out.streaming){
      (*op)(std::cout);
      if(!out.bad()) (*op)(out);
    }
    return out;
  }
  template<typename T>
  friend ofstreamcout& operator<<(ofstreamcout& out, const T& t){
    if(&out and out.streaming){
      if(!out.bad()) static_cast<std::ofstream&>(out) << t;
      std::cout << t;
    }
    return out;
  }
  void turnOn(){
    streaming=true;
  }
  void turnOff(){
    streaming=false;
  }
};
#endif //_OFSTREAMCOUT_H_
/// @}

