/// @addtogroup dynset
/// @{

/////////////////////////////////////////////////////////////////////////////
/// @file dynsetlib.h
///
/// @author Daniel Wilczak
/////////////////////////////////////////////////////////////////////////////

// Copyright (C) 2000-2005 by the CAPD Group.
//
// This file is part of the CAPD library.  This library is free software;
// you can redistribute it and/or modify it under the terms of the GNU
// General Public License as published by the Free Software Foundation;
// either version 2 of the License, or (at your option) any later version.
//
// This library is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU General Public License for more details.
//
// You should have received a copy of the GNU General Public License along
// with this software; see the file "license.txt".  If not, write to the
// Free Software Foundation, Inc., 59 Temple Place - Suite 330, Boston,
// MA 02111-1307, USA.

/** Author: Daniel Wilczak, 2005 */

#ifndef _DynSetLib_H
#define _DynSetLib_H

#include "interval/doubleInterval.h"
#include "vectalg/vectalglib.h"

#include "dynset/ballintf.h"
#include "dynset/ellisetintf.h"
#include "dynset/flowballintf.h"
#include "dynset/intv2setintf.h"
#include "dynset/intvsetintf.h"
#include "dynset/pped2setintf.h"
#include "dynset/ppedsetintf.h"
#include "dynset/rect2setintf.h"
#include "dynset/rectsetintf.h"

#include "dynset/c1rectintf.h"
#include "dynset/c1rect2intf.h"
#include "dynset/c2rect2intf.h"

typedef interval (*v_form)(intervalVector &);
typedef capd::dynset::C0set<intervalMatrix> set;
typedef capd::dynset::C0set<intervalMatrix> C0set;
typedef capd::dynset::BallSet<intervalMatrix> ballSet;
typedef capd::dynset::EllipsoidSet<vector,intervalMatrix> ellipsoidSet;
typedef capd::dynset::FlowballSet<intervalMatrix> flowballSet;
typedef capd::dynset::Intv2Set<intervalMatrix> intv2Set;
typedef capd::dynset::IntervalSet<intervalMatrix> intervalSet;
typedef capd::dynset::Pped2Set<intervalMatrix> pped2Set;
typedef capd::dynset::PpedSet<intervalMatrix> ppedSet;
typedef capd::dynset::Rect2Set<intervalMatrix> rect2Set;
typedef capd::dynset::RectSet<intervalMatrix> rectSet;

typedef capd::dynset::C1set<intervalMatrix> C1set;
typedef capd::dynset::C1rect<intervalMatrix> C1rect;
typedef capd::dynset::C1rect2<intervalMatrix> C1rect2;

typedef capd::dynset::C2set<intervalMatrix> C2set;
typedef capd::dynset::C2rect2<intervalMatrix> C2rect2;

#endif // #define _DynSetLib_H

/// @}
