/// @addtogroup vectalg
/// @{

/////////////////////////////////////////////////////////////////////////////
/// @file imatrixMD.cpp
///
/// @author The CAPD Group
/////////////////////////////////////////////////////////////////////////////

// Copyright (C) 2000-2005 by the CAPD Group.
//
// This file is part of the CAPD library.  This library is free software;
// you can redistribute it and/or modify it under the terms of the GNU
// General Public License as published by the Free Software Foundation;
// either version 2 of the License, or (at your option) any later version.
//
// This library is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU General Public License for more details.
//
// You should have received a copy of the GNU General Public License along
// with this software; see the file "license.txt".  If not, write to the
// Free Software Foundation, Inc., 59 Temple Place - Suite 330, Boston,
// MA 02111-1307, USA.


#include "interval/doubleInterval.h"
#include "vectalg/dimension.h"
#include "vectalg/vector.h"
#include "vectalg/matrix.h"

template class Matrix<interval,0,0>;
template class RowVector<interval,0>;
template class ColumnVector<interval,0>;

template Matrix<interval,0,0> abs <interval,0,0> (const Matrix<interval,0,0>&);
template Matrix<interval,0,0> operator- <interval,0,0> (const Matrix<interval,0,0>&);
template Matrix<interval,0,0> operator+ <interval,0,0> (const Matrix<interval,0,0>&, const Matrix<interval,0,0>&);
template Matrix<interval,0,0> operator- <interval,0,0> (const Matrix<interval,0,0>&, const Matrix<interval,0,0>&);
template Matrix<interval,0,0> operator* <interval,0,0> (const Matrix<interval,0,0>&, const Matrix<interval,0,0>&);
template Vector<interval,0> operator* <interval,0,0> (const Matrix<interval,0,0>&, const Vector<interval,0>&);
template Matrix<interval,0,0> operator* <interval,0,0> (const Matrix<interval,0,0>&, const interval&);
template Matrix<interval,0,0> operator* <interval,0,0> (const interval&, const Matrix<interval,0,0>&);
template Matrix<interval,0,0> operator/ <interval,0,0> (const Matrix<interval,0,0>&, const interval&);
template Matrix<interval,0,0> operator+ <interval,0,0> (const Matrix<interval,0,0>&, const interval&);
template Matrix<interval,0,0> operator- <interval,0,0> (const Matrix<interval,0,0>&, const interval&);
template bool operator< <interval,0,0> (const Matrix<interval,0,0>&, const Matrix<interval,0,0>&);
template bool operator> <interval,0,0> (const Matrix<interval,0,0>&, const Matrix<interval,0,0>&);
template bool operator<= <interval,0,0> (const Matrix<interval,0,0>&, const Matrix<interval,0,0>&);
template bool operator>= <interval,0,0> (const Matrix<interval,0,0>&, const Matrix<interval,0,0>&);
template Matrix<interval,0,0> Transpose <interval,0,0> (const Matrix<interval,0,0>&);
template std::ostream &operator<< <interval,0,0> (std::ostream&, const Matrix<interval,0,0>&);
template std::istream &operator>> <interval,0,0> (std::istream&, Matrix<interval,0,0>&);

// intervalMatrix

typedef Matrix<interval,0,0> IMatrix;
template void splitMatrix<IMatrix>(IMatrix&, IMatrix&);
template IMatrix midMatrix<IMatrix>(const IMatrix&);


// RowVector

template Vector<interval,0> operator+<interval,0>(
      const Vector<interval,0>&,
      const RowVector<interval,0>&
   );
template Vector<interval,0> operator+<interval,0>(
      const RowVector<interval,0>&,
      const Vector<interval,0>&
   );
template Vector<interval,0> operator+<interval,0>(
      const RowVector<interval,0>&,
      const RowVector<interval,0>&
   );

template Vector<interval,0> operator-<interval,0>(
      const Vector<interval,0>&,
      const RowVector<interval,0>&
   );
template Vector<interval,0> operator-<interval,0>(
      const RowVector<interval,0>&,
      const Vector<interval,0>&
   );
template Vector<interval,0> operator-<interval,0>(
      const RowVector<interval,0>&,
      const RowVector<interval,0>&
   );

template interval operator*<interval,0>(
      const Vector<interval,0>&,
      const RowVector<interval,0>&
   );
template interval operator*<interval,0>(
      const RowVector<interval,0>&,
      const Vector<interval,0>&
   );
template interval operator*<interval,0>(
      const RowVector<interval,0>&,
      const RowVector<interval,0>&
   );

template Vector<interval,0> operator-<interval,0>(const RowVector<interval,0>&);
template Vector<interval,0> operator*<interval,0,0>(
      const Matrix<interval,0,0>&, const RowVector<interval,0>&
   );

template Vector<interval,0> operator*<interval,0>(const interval&, const RowVector<interval,0>&);
template Vector<interval,0> operator*<interval,0>(const RowVector<interval,0>&, const interval&);
template Vector<interval,0> operator/<interval,0>(const RowVector<interval,0>&, const interval&);

template std::ostream& operator<< <interval,0>(std::ostream&, const RowVector<interval,0>&);


// ColumnVector

template Vector<interval,0> operator+<interval,0>(
      const Vector<interval,0>&,
      const ColumnVector<interval,0>&
   );
template Vector<interval,0> operator+<interval,0>(
      const ColumnVector<interval,0>&,
      const Vector<interval,0>&
   );
template Vector<interval,0> operator+<interval,0>(
      const ColumnVector<interval,0>&,
      const ColumnVector<interval,0>&
   );

template Vector<interval,0> operator-<interval,0>(
      const Vector<interval,0>&,
      const ColumnVector<interval,0>&
   );
template Vector<interval,0> operator-<interval,0>(
      const ColumnVector<interval,0>&,
      const Vector<interval,0>&
   );
template Vector<interval,0> operator-<interval,0>(
      const ColumnVector<interval,0>&,
      const ColumnVector<interval,0>&
   );

template interval operator*<interval,0>(
      const Vector<interval,0>&,
      const ColumnVector<interval,0>&
   );
template interval operator*<interval,0>(
      const ColumnVector<interval,0>&,
      const Vector<interval,0>&
   );
template interval operator*<interval,0>(
      const ColumnVector<interval,0>&,
      const ColumnVector<interval,0>&
   );

template Vector<interval,0> operator-<interval,0>(const ColumnVector<interval,0>&);
template Vector<interval,0> operator*<interval,0,0>(
      const Matrix<interval,0,0>&,
      const ColumnVector<interval,0>&
   );

template Vector<interval,0> operator*<interval,0>(const interval&, const ColumnVector<interval,0>&);
template Vector<interval,0> operator*<interval,0>(const ColumnVector<interval,0>&, const interval&);
template Vector<interval,0> operator/<interval,0>(const ColumnVector<interval,0>&, const interval&);

template std::ostream& operator<< <interval,0>(std::ostream&, const ColumnVector<interval,0>&);

/// @}
