/// @addtogroup vectalg
/// @{

/////////////////////////////////////////////////////////////////////////////
/// @file vectorMD.cpp
///
/// @author The CAPD Group
/////////////////////////////////////////////////////////////////////////////

// Copyright (C) 2000-2005 by the CAPD Group.
//
// This file is part of the CAPD library.  This library is free software;
// you can redistribute it and/or modify it under the terms of the GNU
// General Public License as published by the Free Software Foundation;
// either version 2 of the License, or (at your option) any later version.
//
// This library is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU General Public License for more details.
//
// You should have received a copy of the GNU General Public License along
// with this software; see the file "license.txt".  If not, write to the
// Free Software Foundation, Inc., 59 Temple Place - Suite 330, Boston,
// MA 02111-1307, USA.

#include <iostream>
#include "vectalg/vector.h"

template class Vector<double,0>;

template Vector<double,0> abs<double> (const Vector<double,0> &v);
template Vector<double,0> operator- <double> (const Vector<double,0> &v);
template Vector<double,0> operator+ <double> (const Vector<double,0> &v1,const Vector<double,0> &v2);
template Vector<double,0> operator- <double> (const Vector<double,0> &v1,const Vector<double,0> &v2);
template double operator* <double> (const Vector<double,0> &v1,const Vector<double,0> &v2);

template Vector<double,0> operator* <double,double> (const Vector<double,0> &v,const double &s);
template Vector<double,0> operator* <double,double> (const double &s,const Vector<double,0> &v);
template Vector<double,0> operator/ <double,double> (const Vector<double,0> &v, const double &s);

template Vector<double,0> operator* <double,long>(const Vector<double,0> &v,const long &s);
template Vector<double,0> operator* <double,long>(const long &s,const Vector<double,0> &v);
template Vector<double,0> operator/ <double,long>(const Vector<double,0> &v, const long &s);

template Vector<double,0> operator* <double,int>(const Vector<double,0> &v,const int &s);
template Vector<double,0> operator* <double,int>(const int &s,const Vector<double,0> &v);
template Vector<double,0> operator/ <double,int>(const Vector<double,0> &v, const int &s);

template Vector<double,0> operator+ <double> (const Vector<double,0> &v,const double &s);
template Vector<double,0> operator- <double> (const Vector<double,0> &v,const double &s);
template bool operator < <double> (const Vector<double,0> &v1,const Vector<double,0> &v2);
template bool operator > <double> (const Vector<double,0> &v1,const Vector<double,0> &v2);
template bool operator<= <double> (const Vector<double,0> &v1,const Vector<double,0> &v2);
template bool operator>= <double> (const Vector<double,0> &v1,const Vector<double,0> &v2);
template std::ostream &operator<< <double> (std::ostream &out, const Vector<double,0> &v);
template std::istream &operator>> <double>(std::istream &inp, Vector<double,0> &v);

/// @}
